#ifndef AESCONSTANTS_H
#define AESCONSTANTS_H

#define MAX_KEY_LENGTH      32
#define MAX_BLOCK_LENGTH    32
#define MAX_STATE_COLS      8   
#define MAX_ROUNDS          14
#define N_ROUNDS            10
#define STATE_ROWS          4
#define STATE_COLS          4   
#define N_BIJECT4X4         100    
#define N_BIJECT8X8         100
#define BLOCK_LENGTH        16
#define KEY_LENGTH          16

static unsigned char shifts[4][2] = {    // shifts[x][0] ... cipher, shifts[x][1] ... inverse
   0, 0,
   1, 3,
   2, 2,
   3, 1
}; 

static unsigned char MC[4][4] = {
    0x02, 0x03, 0x01, 0x01,
    0x01, 0x02, 0x03, 0x01,
    0x01, 0x01, 0x02, 0x03,
    0x03, 0x01, 0x01, 0x02
};

static unsigned char MCi[4][4] = {
    0xe, 0xb, 0xd, 0x9,
    0x9, 0xe, 0xb, 0xd,
    0xd, 0x9, 0xe, 0xb,
    0xb, 0xd, 0x9, 0xe
};

typedef unsigned char       SCHEDULED_KEY[MAX_ROUNDS + 1][4][MAX_BLOCK_LENGTH];

typedef unsigned char       AESMATRIX[STATE_ROWS][MAX_STATE_COLS];              // AES STRUCTURE DEFINITIONS FOR 128 BITS BLOCK

#endif