#ifndef WBACRAESTABLESDEF_H
#define WBACRAESTABLESDEF_H

#include "..\Shared\AESConstants.h"

//
// EXTENDED DATA TYPES
//
typedef unsigned char BYTE;
typedef unsigned long DWORD;       
typedef BYTE          BITS4;                // FORM OF BITS4 is 0000xxxx, ONLY LOWER 4 BITS ARE USED
typedef BYTE    MCSTRIP[4];                 // partitional strip obtained by multiplication with MC            


//
// WBACR AES TABLES DEFINITIONS    
//
typedef MCSTRIP ROUND_TABLE[256];           // 8 x 32 bits table
typedef BITS4   XOR_TABLE[256];             // 8 x 4 bits table
typedef BYTE    FINALROUND_TABLE[256];      // 8 x 8 bits table
typedef BYTE    INVFIRSTROUND_TABLE[256];   // 8 x 8 bits table

typedef struct _WBACR_AES_TABLES {
    // ENCRYPT TABLES
    ROUND_TABLE         ROUND[N_ROUNDS][STATE_COLS][STATE_ROWS];    // ENCRYPT ROUND    
    XOR_TABLE           XOR[N_ROUNDS][STATE_COLS][24];              // 24 == 8 4-BITS PARTS OF 32-BITS DWORD
    FINALROUND_TABLE    FINALROUND[STATE_COLS][STATE_ROWS];
    
    // DECRYPT TABLES
    ROUND_TABLE         INVROUND[N_ROUNDS][STATE_COLS][STATE_ROWS]; // DECRYPT ROUND    
    XOR_TABLE           INVXOR[N_ROUNDS][STATE_COLS][24];           // 24 == 8 4-BITS PARTS OF 32-BITS DWORD
    INVFIRSTROUND_TABLE INVFIRSTROUND[STATE_COLS][STATE_ROWS];
} WBACR_AES_TABLES, *PWBACR_AES_TABLES;


//
// WBACR AES SUPPORT STRUCT DEFINITIONS
//
//typedef BYTE    AESMATRIX[STATE_ROWS][STATE_COLS];                  // AES STRUCTURE DEFINITIONS FOR 128 BITS BLOCK
typedef MCSTRIP AESMATRIXMC[STATE_ROWS][STATE_COLS];                // AES MATRIX WITH CELLS CONTAINING MCSTRIP

#endif