#include "status.h"

const char* ErrorToString(int error) {
    switch (error) {
            // BASE ERROR STATUS
        case STAT_OK:                                   return "SUCCESS";   
        case STAT_NOT_IMPLEMENTED_YET:                  return "NOT_IMPLEMENTED_YET";
        case STAT_SESSION_NOT_OPEN:                     return "SESSION_NOT_OPEN";
        case STAT_NOT_ENOUGHT_MEMORY:                   return "NOT_ENOUGHT_MEMORY";
        case STAT_CHANNEL_SECURITY_NOT_ACHIEVED:        return "CHANNEL_SECURITY_NOT_ACHIEVED";
        case STAT_CHANNEL_DESTROY_FAIL:                 return "CHANNEL_DESTROY_FAIL";
        case STAT_CHANNEL_NOT_EXISTS:                   return "CHANNEL_NOT_EXISTS"; 
        case STAT_INCORRECT_HWT:                        return "INCORRECT_HWT";
        case STAT_INCORRECT_SWA:                        return "INCORRECT_SWA";
        case STAT_DATA_CORRUPTED:                       return "DATA_CORRUPTED";
        case STAT_DATA_INCORRECT_LENGTH:                return "DATA_INCORRECT_LENGTH";
        case STAT_KEY_SCHEDULE_FAIL:                    return "KEY_SCHEDULE_FAIL"; 
        case STAT_CIPHER_INIT_FAIL:                     return "CIPHER_INIT_FAIL"; 
        case STAT_ENCRYPT_FAIL:                         return "ENCRYPT_FAIL"; 
        case STAT_DECRYPT_FAIL:                         return "DECRYPT_FAIL"; 
        case STAT_FILE_OPEN_FAIL:                       return "FILE_OPEN_FAIL"; 
        case STAT_SEAUT_FRESHNESS_FAIL:                 return "SEAUT_FRESHNESS_FAIL";
        case STAT_NO_CONNECTION:                        return "NO_CONNECTION";
        case STAT_NOT_ENOUGHT_DATA_TYPE:                return "NOT_ENOUGHT_DATA_TYPE";
        case STAT_LICENCE_TOO_LONG:                     return "STAT_LICENCE_TOO_LONG";      
        case STAT_RESPONSE_DATA_LENGTH_BAD:             return "STAT_RESPONSE_DATA_LENGTH_BAD";
        case STAT_USERDATA_BAD:                         return "STAT_USERDATA_BAD";
        case STAT_KEY_LENGTH_BAD:                       return "STAT_KEY_LENGTH_BAD";
        case STAT_DATA_TOO_LONG:                        return "STAT_DATA_TOO_LONG";
        case STAT_INI_DATA_WRITE_FAIL:                  return "STAT_INI_DATA_WRITE_FAIL";                             
        case STAT_INI_DATA_READ_FAIL:                   return "STAT_INI_DATA_READ_FAIL";
        case STAT_CODING_NOT_BIJECT:                    return "STAT_CODING_NOT_BIJECT";               
        case STAT_CODING_ALREADY_ASSIGNED:              return "STAT_CODING_ALREADY_ASSIGNED"; 
        case STAT_CONFIG_SCRIPT_INCOMPLETE:             return "STAT_CONFIG_SCRIPT_INCOMPLETE";
        case STAT_IOC_CORRUPTED:                        return "STAT_IOC_CORRUPTED";           
        case STAT_LOAD_AUTH_FNC_FAIL:                   return "STAT_LOAD_AUTH_FNC_FAIL";      
        case STAT_LOAD_LIBRARY_FAIL:                    return "STAT_LOAD_LIBRARY_FAIL";       
        case STAT_SCARD_ERROR:                          return "STAT_SCARD_ERROR";             
        case STAT_FULL_PATH_FAIL:                       return "STAT_FULL_PATH_FAIL";
                               
            // GEMPLUS CARDCOMM ERRORS
        case STAT_CCR_UNKNOWN:                          return "STAT_CCR_UNKNOWN";
        case STAT_CCR_INVALID_HANDLE:                   return "STAT_CCR_INVALID_HANDLE";
        case STAT_CCR_CARD_NOT_PRESENT:                 return "STAT_CCR_CARD_NOT_PRESENT";
        case STAT_CCR_SESSION_NOT_OPENED:               return "STAT_CCR_SESSION_NOT_OPENED";
        case STAT_CCR_INVALID_SLOT_ID:                  return "STAT_CCR_INVALID_SLOT_ID";
        case STAT_CCR_FUNCTION_FAILED:                  return "STAT_CCR_FUNCTION_FAILED";
        case STAT_CCR_CANCELLED:                        return "STAT_CCR_CANCELLED";
                                               
            // ISO7816 ERRORS                           
        case SW_FILE_FULL:                              return "SW_FILE_FULL";
        case SW_UNKNOWN:  				                return "SW_UNKNOWN";
        case SW_CLA_NOT_SUPPORTED: 		                return "SW_CLA_NOT_SUPPORTED";
        case SW_INS_NOT_SUPPORTED: 		                return "SW_INS_NOT_SUPPORTED";
        case SW_CORRECT_LENGTH_00: 		                return "SW_CORRECT_LENGTH_00";
        case SW_WRONG_P1P2:   			                return "SW_WRONG_P1P2";
        case SW_INCORRECT_P1P2:			                return "SW_INCORRECT_P1P2";
        case SW_RECORD_NOT_FOUND: 		                return "SW_RECORD_NOT_FOUND";	
        case SW_FILE_NOT_FOUND: 		                return "SW_CLA_NOT_SUPPORTED";
        case SW_FUNC_NOT_SUPPORTED:		                return "SW_FUNC_NOT_SUPPORTED";
        case SW_WRONG_DATA:   			                return "SW_WRONG_DATA";
        case SW_APPLET_SELECT_FAILED: 	                return "SW_APPLET_SELECT_FAILED";
        case SW_COMMAND_NOT_ALLOWED: 	                return "SW_COMMAND_NOT_ALLOWED";
        case SW_CONDITIONS_NOT_SATISFIED:               return "SW_CONDITIONS_NOT_SATISFIED";
        case SW_DATA_INVALID: 			                return "SW_DATA_INVALID";
        case SW_FILE_INVALID: 			                return "SW_FILE_INVALID";
        case SW_SECURITY_STATUS_NOT_SATISFIED:          return "SW_SECURITY_STATUS_NOT_SATISFIED";
        case SW_WRONG_LENGTH:         			        return "SW_WRONG_LENGTH";
        case SW_BYTES_REMAINING_00:       		        return "SW_BYTES_REMAINING_00";
        case SW_NO_ERROR:             			        return "SW_NO_ERROR";
                                                        
            // MY OWN APPLET ERRORS                     
        case SW_SECURITY_NOT_SATISFIED:			        return "SW_SECURITY_NOT_SATISFIED";
        case SW_USAGE_UPDATE_FAIL:	                    return "SW_USAGE_UPDATE_FAIL";
        case SW_USAGE_NOT_ALLOWED:	                    return "SW_USAGE_NOT_ALLOWED";
        case SW_ALG_UUID_NOT_UNIQUE:                    return "SW_ALG_UUID_NOT_UNIQUE";
        case SW_ALG_CONTAINER_FULL:                     return "SW_ALG_CONTAINER_FULL";
        case SW_ALG_UUID_NOT_FOUND:                     return "SW_ALG_UUID_NOT_FOUND";
        case SW_SWA_UUID_NOT_UNIQUE:                    return "SW_SWA_UUID_NOT_UNIQUE";
        case SW_SWA_CONTAINER_FULL:                     return "SW_SWA_CONTAINER_FULL";
        case SW_BAD_KEY:                                return "SW_BAD_KEY";
        case SW_ALG_TYPE_UNKNOWN:                       return "SW_ALG_TYPE_UNKNOWN";
        case SW_ALG_UUID_BAD_LENGTH:                    return "SW_ALG_UUID_BAD_LENGTH";
        case SW_SWA_UUID_BAD_LENGTH:                    return "SW_SWA_UUID_BAD_LENGTH";
        case SW_HWT_UUID_BAD:                           return "SW_HWT_UUID_BAD";
        case SW_SWA_UUID_BAD:                           return "SW_SWA_UUID_BAD";
        case SW_XML_UNEXPECTED_ELEM:                    return "SW_XML_UNEXPECTED_ELEM";
        case SW_XML_UNEXPECTED_END:                     return "SW_XML_UNEXPECTED_END";
        case SW_LICENCE_OUTDATED:                       return "SW_LICENCE_OUTDATED";
        case SW_SWA_PERMIT_ALG_FULL:                    return "SW_SWA_PERMIT_ALG_FULL";
        case SW_ALG_SWA_NOT_PERMITED:                   return "SW_ALG_SWA_NOT_PERMITED";
        case SW_LICENCE_OUTOFORDER:                     return "SW_LICENCE_OUTOFORDER";
        case SW_SEAUT_STOP_MESSAGE_BAD:                 return "SW_SEAUT_STOP_MESSAGE_BAD";
        case SW_SWA_AUTH_REQUIRED:                      return "SW_SWA_AUTH_REQUIRED";
        case SW_ENCRYPT_FAIL:                           return "SW_ENCRYPT_FAIL";
        case SW_SWA_NOT_FOUND:                          return "SW_SWA_NOT_FOUND";
        case SW_ALG_NOT_FOUND:                          return "SW_ALG_NOT_FOUND";
        case SW_XMLPARSER_INSUFFICIENT_DATA:            return "SW_XMLPARSER_INSUFFICIENT_DATA";
        case SW_XMLPARSER_INVALID_DATA:                 return "SW_XMLPARSER_INVALID_DATA";
        case SW_XMLPARSER_UNKNOWN_ERROR:                return "SW_XMLPARSER_UNKNOWN_ERROR";
        case SW_IV_BAD:                                 return "SW_IV_BAD";
        case SW_CIPHER_DATA_LENGTH_BAD:                 return "SW_CIPHER_DATA_LENGTH_BAD";
        case SW_MESSAGE_LENGTH_BAD:                     return "SW_MESSAGE_LENGTH_BAD";
        case SW_SEAUT_STEP_BAD:                         return "SW_SEAUT_STEP_BAD";
        case SW_SEAUT_FRESHNESS_FAIL:                   return "SW_SEAUT_FRESHNESS_FAIL";
        case SW_KEY_LENGTH_BAD:                         return "SW_KEY_LENGTH_BAD";
        case SW_ALG_INPUT_BAD:                          return "SW_ALG_INPUT_BAD";


        default:                                        return "'unknown'";   
    }
}  

