#ifndef STATUS_H
#define STATUS_H

#define STAT_OK                                 0       // OK
#define STAT_NOT_IMPLEMENTED_YET                1       // REQUESTED BEHAVIOUR NOT IMPLEMENTED YET
#define STAT_SESSION_NOT_OPEN                   2       // SESSION IS NOT OPEN, TRY TO OPEN SESSION BEFORE CALLING THIS FUNCTION
#define STAT_NOT_ENOUGHT_MEMORY                 3       // NOT ENOUGHT MEMORY TO COMPLETE REQUESTED OPERATION, TRY TO INCREASE GIVEN MEMORY BUFFER SIZE
#define STAT_CHANNEL_SECURITY_NOT_ACHIEVED      4       // LOGICAL CHANNEL SECURITY NOT ACHIVED TO REQUESTED LEVEL
#define STAT_CHANNEL_DESTROY_FAIL               5       // FAIL TO DESTROY LOGICAL CHANNEL
#define STAT_CHANNEL_NOT_EXISTS                 6       // LOGICAL CHANNEL NOT EXIST YET, TRY TO CREATE CHANNEL BEFORE CALLING THIS FUNCTION
#define STAT_INCORRECT_HWT                      7       // INCORRECT TARGET HARDWARE TOKEN 
#define STAT_INCORRECT_SWA                      8       // INCORRECT TARGET SOFTWARE AGENT
#define STAT_DATA_CORRUPTED                     10      // GIVEN DATA ARE NOT IN EXPECTED FORMAT   
#define STAT_DATA_INCORRECT_LENGTH              11      // LENGTH OF GIVEN DATA IS INCORRECT
#define STAT_KEY_SCHEDULE_FAIL                  12      // FAIL TO SCHEDULE CIPHER KEY MATERIAL    
#define STAT_CIPHER_INIT_FAIL                   13      // FAIL TO INICIALIZE CIPHER ENGINE
#define STAT_ENCRYPT_FAIL                       14      // FAIL TO COMPLETE ENCRYPTION OPERATION
#define STAT_DECRYPT_FAIL                       15      // FAIL TO COMPLETE DECRYPTION OPERATION
#define STAT_FILE_OPEN_FAIL                     16      // FAIL TO OPEN TARGET FILE
#define STAT_SEAUT_FRESHNESS_FAIL               17      // MESSAGE RECIEVED DURING SEAUT PROTOCOL IS NOT FRESH, ACCIDENTAL DAMAGE OF DATA OR REPLAY ATTACK DETECTED
#define STAT_NO_CONNECTION                      18      // NO EXISTING CONNECTION, TRY TO ESTABILISH CONNECTION BEFORE CALLING THIS FUNCTION
#define STAT_NOT_ENOUGHT_DATA_TYPE              20      // GIVEN DATA VARIABLE IS UNABLE TO CONTAIN RETURN VALUE
#define STAT_LICENCE_TOO_LONG                   21      // LICENCE LENGTH IS BIGGER THAN MAX. ALLOWED
#define STAT_RESPONSE_DATA_LENGTH_BAD           22      // RESPONSE DATA LENGTH DIFFERS FROM EXPECTED 
#define STAT_USERDATA_BAD                       23      // DATA OBTAINED FROM USER INPUT ARE INVALID
#define STAT_KEY_LENGTH_BAD                     24      // KEY LENGTH DIFFERS FROM EXPECTED
#define STAT_DATA_TOO_LONG                      25      // DATA LENGTH IS BIGGER THAN MAX. ALLOWED
#define STAT_INI_DATA_WRITE_FAIL                26      // FAIL TO WRITE DATA INTO INI FILE                             
#define STAT_INI_DATA_READ_FAIL                 27      // FAIL TO READ DATA FROM INI FILE                    
#define STAT_CODING_NOT_BIJECT                  28
#define STAT_CODING_ALREADY_ASSIGNED            29
#define STAT_CONFIG_SCRIPT_INCOMPLETE           30      // MISSING ITEMS IN CONFIGURATION SCRIPT    
#define STAT_IOC_CORRUPTED                      31      // I/O CODINGS FORMAT INCORRECT
#define STAT_LOAD_AUTH_FNC_FAIL                 32
#define STAT_LOAD_LIBRARY_FAIL                  33
#define STAT_SCARD_ERROR                        34      // SCARD FUNCTIONS ERROR OCCURED. ERROR VALUE SHOULD BE STORED SOMEWHERE IN OBJECT (::GetLastSCardError()) 
#define STAT_FULL_PATH_FAIL                     35      // FAIL TO CREATE FULL FILE PATH

    // MY OWN APPLET ERRORS
#define SW_SECURITY_NOT_SATISFIED           0x6680      // PIN IS BLOCKED NOW
#define SW_USAGE_UPDATE_FAIL	            0x6681      // FAIL TO UPDATE ALGORITHM USAGE COUNTER
#define SW_USAGE_NOT_ALLOWED	            0x6682      // UPDATE OF ALGORITHM USAGE COUNTER IS NOT ALLOWED
#define SW_ALG_UUID_NOT_UNIQUE              0x6683      // ALGORITHM WITH GIVEN UUID ALREADY EXISTS
#define SW_ALG_CONTAINER_FULL               0x6684      // NO MORE ALGORITHMS CAN BE CREATED
#define SW_ALG_UUID_NOT_FOUND               0x6685      // ALGORITHM WITH GIVEN UUID NOT EXISTS
#define SW_SWA_UUID_NOT_UNIQUE              0x6686      // SOFTWARE AGENT'S PROFILE WITH GIVEN UUID ALREADY EXISTS
#define SW_SWA_CONTAINER_FULL               0x6687      // NO MORE SOFTWARE AGENT PROFILES CAN BE CREATED
#define SW_BAD_KEY                          0x6688      // INCORRECT KEY
#define SW_ALG_TYPE_UNKNOWN                 0x6689      // UNKNOWN TYPE OF NEW ALGORITHM (GIVEN IN MASTER LICENCE)
#define SW_ALG_UUID_BAD_LENGTH              0x6690      // BAD LENGTH OF ALGORITHM UUID
#define SW_SWA_UUID_BAD_LENGTH              0x6691      // BAD LENGTH OF SOFTWARE AGENT PROFILE UUID
#define SW_HWT_UUID_BAD                     0x6692      // GIVEN HARDWARE TOKEN UUID IS INCORRECT 
#define SW_SWA_UUID_BAD                     0x6693      // GIVEN SOFTWARE AGENT UUID IS INCORRECT 
#define SW_XML_UNEXPECTED_ELEM              0x6694      // UNEXPECTED XML ELEMENT FOUND DURING LICENCE PARSING
#define SW_XML_UNEXPECTED_END               0x6695      // UNEXPECTED END OF XML ELEMENT FOUND DURING LICENCE PARSING
#define SW_LICENCE_OUTDATED                 0x6696      // LICENCE WITH GIVEN ORDINARY NUMBER IS OUTDATED 
#define SW_SWA_PERMIT_ALG_FULL              0x6697      // NO AVAILABLE FREE SLOTS FOR SWA WHICH CAN BE PERMITED TO ALGORITHM
#define SW_ALG_SWA_NOT_PERMITED             0x6698      // USAGE OF ALGORITHM IS NOT PERMITED FOR GIVEN SOFTWARE AGENT
#define SW_LICENCE_OUTOFORDER               0x6699      // GIVEN LICENCE IS OUT OF ORDER (NOT DIRECT SUCCESSOR OF LAST ACCEPTED LICENCE), USE SPECIAL FLAG TO PARSE THIS LICENCE 
        // 0x6700 RESERVED ISO7816 ERROR
#define SW_SWA_AUTH_REQUIRED                0x6701      // AUTHENTIZATION OF SWA IS REQUIRED FOR REQUESTED OPERATION
#define SW_ENCRYPT_FAIL                     0x6702      // FAIL TO COMPLETE ENCRYPTION OPERATION
#define SW_DECRYPT_FAIL                     0x6703      // FAIL TO COMPLETE DECRYPTION OPERATION
#define SW_SWA_NOT_FOUND                    0x6704      // FAIL TO FOUND SOFTWARE AGENT PROFILE BY GIVEN UUID
#define SW_ALG_NOT_FOUND                    0x6705      // FAIL TO FOUND ALGORITHM BY GIVEN UUID
#define SW_XMLPARSER_INSUFFICIENT_DATA      0x6706      // NOT ALL REQUIRED INFORMATION OBTAINED WHEN END OF LICENCE REACHED
#define SW_XMLPARSER_INVALID_DATA           0x6707      // INVALID DATA FORMAT FOUND DURING LICENCE PARSING    
#define SW_XMLPARSER_UNKNOWN_ERROR          0x6708      // UNKNOWN ERROR OCCURED DURING LICENCE PARSING 
#define SW_IV_BAD                           0x6709      // BAD INICIALIZATION VECTOR
#define SW_CIPHER_DATA_LENGTH_BAD           0x6710      // BAD LENGTH OF DATA USED DURING CIPHER OPERATION     
#define SW_MESSAGE_LENGTH_BAD               0x6711      // BAD LENGTH OF MESSAGE OBTAINED DURING PROTOCOl (SEAUT)
#define SW_SEAUT_STEP_BAD                   0x6712      // INCORRECT MESSAGE ORDER OF AUTHENTICATION PART OF SEAUT
#define SW_SEAUT_FRESHNESS_FAIL             0x6713      // MESSAGE RECIEVED DURING SEAUT PROTOCOL IS NOT FRESH, ACCIDENTAL DAMAGE OF DATA OR REPLAY ATTACK DETECTED
#define SW_SEAUT_STOP_MESSAGE_BAD           0x6714      // BAD STOP MESSAGE USED TO FINALIZE SEAUT PROTOCOL
#define SW_KEY_LENGTH_BAD                   0x6715      // BAD KEY LENGTH
#define SW_ALG_INPUT_BAD                    0x6716      // FORMAT OF INPUT DATA FOR ALGORITHM IS BAD

    // ISO7816 ERRORS
#define SW_FILE_FULL                        0x6A84
#define SW_UNKNOWN  				        0x6F00
#define SW_CLA_NOT_SUPPORTED 		        0x6E00
#define SW_INS_NOT_SUPPORTED 		        0x6D00
#define SW_CORRECT_LENGTH_00 		        0x6C00
#define SW_WRONG_P1P2   			        0x6B00
#define SW_INCORRECT_P1P2			        0x6A86
#define SW_RECORD_NOT_FOUND 		        0x6A83	
#define SW_FILE_NOT_FOUND 			        0x6A82
#define SW_FUNC_NOT_SUPPORTED		        0x6A81
#define SW_WRONG_DATA   			        0x6A80
#define SW_APPLET_SELECT_FAILED 	        0x6999
#define SW_COMMAND_NOT_ALLOWED 		        0x6986
#define SW_CONDITIONS_NOT_SATISFIED         0x6985
#define SW_DATA_INVALID 			        0x6984
#define SW_FILE_INVALID 			        0x6983
#define SW_SECURITY_STATUS_NOT_SATISFIED    0x6982
#define SW_WRONG_LENGTH         			0x6700
#define SW_BYTES_REMAINING_00       		0x6100
#define SW_NO_ERROR             			0x9000	
     
    // GEMPLUS CARDCOMM ERRORS
#define STAT_CCR_UNKNOWN                    0x1000
#define STAT_CCR_INVALID_HANDLE				0x1001
#define STAT_CCR_CARD_NOT_PRESENT			0x1002
#define STAT_CCR_SESSION_NOT_OPENED			0x1003
#define STAT_CCR_INVALID_SLOT_ID			0x1004
#define STAT_CCR_FUNCTION_FAILED			0x1005
#define STAT_CCR_CANCELLED					0x1006


const char* ErrorToString(int error);

#define ERROR_TO_STRING(x) ErrorToString(x)

#endif