#ifndef AESCIPHER_H
#define AESCIPHER_H

#include "..\Shared\AESConstants.h"
#include <stdlib.h>
#include <afx.h>

class CSecFunctProvider {
public: 

    //
    //  STANDARD AES CIPHERING METHODS
    //
    //  NOTE: WHEN bStrengthLastBlock IS TRUE, THAN STRENGTHENED VERSION RESISTENT AGAINST VAUDENAY "CBC-PADDING ATTACK" IS USED
    static int AES128_EncryptCBC(BYTE* pbBuffer, DWORD* pcbBufferLen, DWORD* pcbMaxBufferLen, BYTE rawKey[KEY_LENGTH], const BYTE IV[BLOCK_LENGTH], BOOL bStrengthLastBlock = FALSE);
    static int AES128_DecryptCBC(BYTE* pbBuffer, DWORD* pcbBufferLen, BYTE rawKey[KEY_LENGTH], const BYTE IV[BLOCK_LENGTH], BOOL bStrengthLastBlock = FALSE);
    
//    static int AES128_EncryptCBC(BYTE* pbBuffer, DWORD* pcbBufferLen, DWORD* pcbMaxBufferLen, char* keyMaterial, const BYTE IV[BLOCK_LENGTH]);
//    static int AES128_DecryptCBC(BYTE* pbBuffer, DWORD* pcbBufferLen, char* keyMaterial, const BYTE IV[BLOCK_LENGTH]);

    static int AES_EncryptOneBlock(BYTE plainBlock[BLOCK_LENGTH], BYTE rawKey[KEY_LENGTH]); 
    static int AES_EncryptOneBlock(BYTE plainBlock[BLOCK_LENGTH], BYTE rawKey[KEY_LENGTH], int nRounds); 

    static int AES_EncryptOneBlock(char* keyMaterial, BYTE plainBlock[BLOCK_LENGTH], BYTE encryptedBlock[BLOCK_LENGTH], int nRounds); 
    static int AES_EncryptOneBlock(char* keyMaterial, BYTE plainBlock[BLOCK_LENGTH], BYTE encryptedBlock[BLOCK_LENGTH]); 

    static int AES128_EncryptOneBlock(BYTE pbBlock[BLOCK_LENGTH], BYTE pbScheduledKey[N_ROUNDS][4][BLOCK_LENGTH]); 

    static int AES_DecryptOneBlock(char* keyMaterial, BYTE encryptedBlock[BLOCK_LENGTH], BYTE plainBlock[BLOCK_LENGTH], int nRounds); 
    static int AES_DecryptOneBlock(char* keyMaterial, BYTE encryptedBlock[BLOCK_LENGTH], BYTE plainBlock[BLOCK_LENGTH]); 
    static int AES_DecryptOneBlock(BYTE pbBlock[BLOCK_LENGTH]); 

    
    // INSERT BUFFER PADDING TO BLOCK_LENGTH MULTIPLE (USED FOR CBC MODE)
    static int InsertCBCPadding(BYTE* pbBuffer, DWORD* pcbBufferLen, DWORD* pcbMaxBufferLen);
    // REMOVE BUFFER PADDING (USED FOR CBC MODE)
    static int RemoveCBCPadding(BYTE* pbBuffer, DWORD* pcbBufferLen);

    // PREPARE AES MATRIX FROM RAW BUFFER
    static int PrepareAESMatrix(BYTE* block, int blockLength, AESMATRIX aesMatrix); 
    
    // PREPARE RAW KEY FROM STRING KEY MATERIAL
    static int PrepareRawKey(char* keyMaterial, BYTE rawKey[KEY_LENGTH]);


};

#endif
