#ifndef WAESCIPHER_H
#define WAESCIPHER_H

#include "..\Shared\WBACRAESTablesDef.h"
#include "..\Shared\AESConstants.h"
#include <stdlib.h>
#include <afx.h>

class CWAESCipher {
public:
    WBACR_AES_TABLES*   m_pTables;              // WBACR AES PRECACULATED TABLES (EMEDDED WBACR AES TABLES AREN'T USED) 
    BYTE                m_IV[BLOCK_LENGTH];     // INICIALIZATION VECTOR FOR CBC MODE
public: 
    CWAESCipher();

    int SetTables(WBACR_AES_TABLES* pTables);
    
    // WBACR_AES CIPHERING METHODS   
    int WBACRAES128_EncryptCBC(BYTE* pbBuffer, DWORD* pcbBufferLen, DWORD* pcbMaxBufferLen, BOOL bUsePadding = TRUE);
    int WBACRAES128_DecryptCBC(BYTE* pbBuffer, DWORD* pcbBufferLen, BOOL bUsePadding = TRUE);

    int WBACRAES_EncryptOneBlock(BYTE plainBlock[BLOCK_LENGTH], BYTE encryptedBlock[BLOCK_LENGTH]); 
    int WBACRAES_EncryptOneBlock(BYTE pbBlock[BLOCK_LENGTH]); 

    int WBACRAES_DecryptOneBlock(BYTE encryptedBlock[BLOCK_LENGTH], BYTE plainBlock[BLOCK_LENGTH]); 
    int WBACRAES_DecryptOneBlock(BYTE pbBlock[BLOCK_LENGTH]); 

    // VIRTUAL METHODS INTENDED TO BE OVERRIDED WHEN EMBEDDED WBACR AES TABLES ARE USED
    virtual int WBACRAES_EncryptOneBlock(BYTE plainBlock[BLOCK_LENGTH], BYTE encryptedBlock[BLOCK_LENGTH], int nRounds); 
    virtual int WBACRAES_DecryptOneBlock(BYTE encryptedBlock[BLOCK_LENGTH], BYTE plainBlock[BLOCK_LENGTH], int nRounds); 

protected:
    inline  BYTE    GET_LOWER(BYTE x) { x <<= 4; x >>= 4; return x; }   // SHIFT LOW 4-BITS TO HIGH AND BACK
    inline  BYTE    GET_HIGHER(BYTE x) { x >>= 4; return x; }           // SHIFT HIGH 4 BITS TO LOW 4-BITS
    inline  BYTE    LOWER(BYTE x) { return GET_LOWER(x); }              // FROM yyyyxxxx MAKES 0000xxxx 
    inline  BYTE    HIGHER(BYTE x) { x <<= 4; return x; }               // FROM yyyyxxxx MAKES xxxx0000
};


#endif